package avalon;

import CoreMDELite.ConformanceError;
import CoreMDELite.Globals;
import java.io.File;

public class Main {

    static {
        Globals.appPath = Globals.getPath(avalon.Main.class);
    }

    public static void setAppPath(boolean printme) {
        if (printme) {
            System.out.println("AppPath : " + Globals.appPath);
        }
    }

    public static void marquee() {
        System.err.format("\nUsage: %s <option> <files>\n",Main.class.getName());
        System.err.format("Format: <file> = <filename>.<domain>.<domainType>\n\n");
        System.err.format("Option: conform <classname> <filename>\n");
        System.err.format("        <classname> in { AvalonSpec AvalonSpecCD ClassViolet Meta Metamodel Schema Start VioletPl }\n");
        buildlist();
        System.err.format("        coordinates\n");
        System.exit(1);
    }

    public static void main(String... args) {
        Globals.cleanup = true;
        try {
            doit(args);
        } catch (Error e) {
            System.err.format("Runtime Error!\n\n");
            Utils.PrintFile.main(Globals.errorFile);
            return;
        } catch (ConformanceError e) {
            System.err.println("Conformance Error!\n");
            Utils.PrintFile.main(Globals.conformFile);
            return;
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
    }

    public static void doit(String... args) {
        if (args.length == 0) {
            marquee();
        } else {
            switch (args[0]) {
                case "buildClass":
                    buildClass(args);
                    break;
                case "buildState":
                    buildState(args);
                    break;
                case "conform":
                    conform(args);
                    break;
                case "coordinates":
                    coordinates(args);
                    break;
                case "help":
                    help(args);
                    break;
                default:
                    System.out.println("Unrecognized option: " + args[0]);
                    System.out.println();
                    marquee();
            }
        }
        new File(Globals.conformFile).delete();
        new File(Globals.errorFile).delete();
    }

    static public void coordinates(String args[]) {
      System.out.println("HomePath = " + Globals.homePath);
      System.out.println("AppPath  = " + Globals.appPath);
    }

    static public void buildClass(String args[]) {
        if (args.length != 2) {
            marquee();
            return;
        }
        String filename = args[1];
        AvalonSpec v0 = new AvalonSpec(filename);
        Meta v1 = v0.toMeta();
        java.util.List<ClassViolet> v2 = v1.toClasses();
        for (ClassViolet v3 : v2) {
            VioletPl v4 = v3.toViolet();
            Schema v5 = v3.toSchema();
        }
        Metamodel v6 = v1.toMetamodel();
        System.out.format("file %s was produced.\n", v6.fullName);
    }

    static public void buildState(String args[]) {
        if (args.length != 2) {
            marquee();
            return;
        }
        String filename = args[1];
        AvalonSpecCD v0 = new AvalonSpecCD(filename);
        Meta v1 = v0.cd2meta();
        java.util.List<ClassViolet> v2 = v1.toClasses();
        for (ClassViolet v3 : v2) {
            VioletPl v4 = v3.toViolet();
            Schema v5 = v3.toSchema();
        }
        Metamodel v6 = v1.toMetamodel();
        System.out.format("file %s was produced.\n", v6.fullName);
    }

    static public void help(String args[]) {
        if (args.length != 2) {
            marquee();
            return;
        }
        String filename = args[1];
        Start v0 = new Start(filename);
        Start v1 = v0.getStarted();
        System.out.format("file %s was produced.\n", v1.fullName);
    }

    static void buildlist() {
        System.err.format("        buildClass      <filename>    // of type class.violet\n");
        System.err.format("        buildState      <filename>    // of type state.violet\n");
        System.err.format("        help            <filename>    // of type start.tmp\n");
    }

    public static void conform(String args[]) {
        if (args.length != 3) {
            marquee();
            return;
        }
        String classname = args[1];
        String filename = args[2];

        switch (classname) {
            case "AvalonSpec":
                AvalonSpec v0 = new AvalonSpec(filename);
                v0.toMeta();
                break;
            case "AvalonSpecCD":
                AvalonSpecCD v1 = new AvalonSpecCD(filename);
                v1.cd2meta();
                break;
            case "ClassViolet":
                ClassViolet v2 = new ClassViolet(filename);
                v2.toViolet();
                break;
            case "Meta":
                Meta v3 = new Meta(filename);
                v3.conform();
                break;
            case "Metamodel":
                System.out.println("no conformance rules");
                break;
            case "Schema":
                System.out.println("no conformance rules");
                break;
            case "Start":
                System.out.println("no conformance rules");
                break;
            case "VioletPl":
                VioletPl v4 = new VioletPl(filename);
                v4.conform();
                break;
            default:
                System.out.println("unrecognizable classname " + classname);
                System.out.println();
                marquee();
        }
    }
}
