package avalon.categoryClassVioletParser;



import java.util.HashMap;

public class ClassNode extends ClassInterface {

    private HashMap<String, String> fields;
    protected String parentId = "";

    public ClassNode(String id, String classType) {
        super(id, classType);

        fields = new HashMap<>();
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parId) {
        String stripped = Main.makeFirstLowerCase(parId);
        if (this.parentId.equals("")) {
            this.parentId = stripped;
        } else {
            Main.errout("multiple superclasses for class " + name);
        }
    }

    public void addAttribute(String attribute) {
        attribute = attribute.trim();
        if (attribute.equals("")) 
            return;  // nothing to do
        
        String terms[] = attribute.replace(" ","").split("=");
        if (terms.length != 2) {
            Main.errout("attribute = value format incorrect : " + attribute);
            return;
        }
        if (fields.containsKey(terms[0])) {
            Main.errout("multiple attributes with name " + terms[0] + " in classId " + this.id);
        } else {
            fields.put(terms[0], terms[1]);
        }
    }

    public HashMap<String,String> getFields() {
        return fields;
    }

    @Override
    public String toString() {
        String str = super.toString();

        str += ", Attributes:";
        for (String attribute : fields.keySet()) {
            str = str + " " + attribute + "=" + fields.get(attribute);
        }
        return str;
    }
}
