package avalon.categoryClassVioletParser;



import PrologDB.*;
import java.util.ArrayList;

public class Method {

    String clas;
    String type;
    String name;
    String[] sigs;
    String fileName;
    String ext;

    public Method(String clas, String type, String name, String[] sigs, String fileName, String ext) {
        this.clas = clas;
        this.type = type;
        this.name = name;
        this.sigs = sigs;
        this.fileName = fileName;
        this.ext = ext.toLowerCase();
    }
    
    public String toString() {
        String result = type + " " + name + "(";
        String comma = "";
        for (String i : sigs) {
            result = result + comma +  i ;
            comma = ",";
        }
        return result + ")";
    }
    
    public Tuple makeTuple(TableSchema ts, int id) {
        String methodList = "";
        String comma="";
        ArrayList<ClassNode> classList = Importer.current.classNodes;
        
        for (String s :sigs) {
            String trueName = s.replace("[]", "");
            if (!contains(classList,trueName)) {
                Main.errout("unrecognizable argument type "+ trueName + " in method "+name);
            }
            methodList = methodList+comma+s;
            comma=",";
        }
        if (!contains(classList,type.replace("[]", ""))) {
            Main.errout("unrecognizable return type " + type + " in method " + name);
        }
        if (!(ext.equals("pl") || ext.equals("java") || ext.equals("vm")) || ext.equals("PL")) {
            Main.errout("extension `" + ext + "' must be pl or java or vm");
        }
        //table(method,[id,\"cid\",\"name\",\"resulttype\",\"sig\",\"filename\",ext]
        Tuple t = new Tuple(ts);
        t.addColumnValue("id","id"+id).addColumnValue("cid",clas).addColumnValue("name",name);
        t.addColumnValue("resulttype",type).addColumnValue("sig", methodList);
        t.addColumnValue("filename",fileName).addColumnValue("ext", ext);
        return t;
    }
    
    public boolean contains(ArrayList<ClassNode> cl, String name) {
        for (ClassNode c : cl) {
            if (c.name.equals(name))
                return true;
        }
        return false;
    }

}
