package avalon.class2schema;

import java.util.ArrayList;

public class ClassNode extends ClassInterface {

    private ArrayList<String> attributes;
    protected String parentId = "";

    public ClassNode(String id, String classType) {
        super(id, classType);

        attributes = new ArrayList<>();
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public void setAttribute(String attribute) {
        this.attributes.add(attribute);
    }
    
    public void addAttributes(ArrayList<String> list) {
        attributes.addAll(0,list);
    }

    public ArrayList<String> getAttributes() {
        return attributes;
    }

    @Override
    public String toString() {
        String str = super.toString();

        str += ", Attributes:";
        for (String attribute : attributes) {
            str += " " + attribute;
        }

        return str;
    }
}
