package avalon.class2schema;

public class Main {

    static String inputFile;

    /**
     * Main
     */
    public static void main(String... args) {

        // Standard marquee test
        if (args.length != 2 || !(args[0].endsWith(".class.violet") && args[1].endsWith(".schema.pl")) ) {
            System.err.format("Usage: %s <in.class.violet> <out.schema.pl>\n",Main.class.getName());
            System.exit(1);
        }

        inputFile = args[0];

        //Import XML data into Java objects
        Importer importer = new Importer(inputFile);

        importer.importNodesAndEdges();

        importer.assignParents();

        //Write our Violet DB file
        DBWriter dbWriter = new DBWriter(inputFile, args[1], importer.getClassNodes(), importer.getClassEdges(),
                importer.getClassInterfaces(), importer.getVioletData(), importer.getNumNodes());

        dbWriter.generateSchema();
    }
}
