/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package avalon.toClasses;

import PrologDB.Table;
import PrologDB.ReadPrologDB;
import PrologDB.DB;
import PrologDB.Tuple;
import CoreMDELite.AdviceUtilities;
import CoreMDELite.Error;
import CoreMDELite.Globals;
import avalon.ClassViolet;
import java.io.File;
import java.io.PrintStream;


/**
 *
 * @author don
 */
public class Main {
    
    public static void marquee() {
        System.out.println("Usage: toclasses.Main <file.meta.pl>");
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String... args) {
        File inputFile;
        PrintStream eps;
        DB db;
        
        // Step 1: let's make sure we open everything properly
        if (args.length != 1) {
            System.err.format("Usage: %s <file.meta.pl>\n",Main.class.getName());
            System.exit(1);
        }
        try {
            inputFile = new File(args[0]);
        }
        catch (Exception e) {
            throw new Error("can't open file "+ args[0]);
        }
        try {
            eps = new PrintStream(Globals.errorFile);
        }
        catch(Exception e){
            throw new Error("can't open file "+Globals.errorFile);
        }
        //db = new ReadPrologDatabase(inputFile,eps);
        db = ReadPrologDB.readDataBase(inputFile,eps);
        eps.close();
        
        // Step 2: foreach prolog domain, tell the user what to do, run violet
        //         and see if it was done properly
        // schema is a map of (tableName,array-list-of-column-names)
        // tables is a map of (tableName, list-of-tuples) where a tuple is a map 
        // (columnName,value) pairs
        
        Table classTable = db.getTable("class");
        String dbDiagram;
        for (Tuple t : classTable.getTuples()) {
            String ext = t.get("ext").toLowerCase();
            String dom = t.get("name").toLowerCase();
            dbDiagram = dom+".class.violet";
            
            if (t.get("ext").equals("pl")) {  // "ext" could be "PL" or "Pl"... which we differentiate from "pl"
                File d = new File(dbDiagram);
                new ClassViolet(dom);  // make object -- but do nothing with it.
                if (!d.exists()) {
                    
                    AdviceUtilities.post("now create a violet class diagram file " + dbDiagram + " to define a schema for domain " + dom +
                    "\nclose the editor when you are done");
                    try {
                        CoreMDELite.MDELiteObject.executeCommandLine("java","com.horstmann.violet.UMLEditor");
//                    com.horstmann.violet.UMLEditor.main(args);
                        //AdviceUtilities.silentExe("java","com.horstmann.violet.UMLEditor");
                    } catch (Exception ex) {
  //                      throw new ExecutionError("violet terminated abnormally");
                    }
                }
            }
        }

    }
    
}
