package tometamodel;

import avalon.tometamodel.common;
import avalon.tometamodel.GenLibs;
import avalon.tometamodel.GenMainClasses;
import CoreMDELite.Globals;
import CoreMDELite.PrologObject;
import java.io.PrintStream;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 *
 * @author don
 */
public class AvalonBootStrapTest extends common {

    public AvalonBootStrapTest() {
        RegTest.Utility.init();
        Globals.setHomePath(false);
        avalon.Main.setAppPath(false);
        Globals.cleanup = false;
    }

    @Before
    public void setUp() {
        copy2MainDir("violetpl.schema.pl");
        copy2MainDir("meta.schema.pl");
    }

    public void copy2MainDir(String file) {
        PrintStream out = null;
        String original = "libpl/" + file;
        try {
            out = new PrintStream(file);
        } catch (Exception e) {
            assert (false);
        }
        PrologObject.addFiletoPS(original, out);
        out.close();
    }

    @After
    public void tearDown() {
    }

    @Test
    public void mdeliteappTest() {
        avalonGenDomainClasses();
        avalonGenMainClasses();
        avalonGenLibs();
    }

    public void avalonGenDomainClasses() {
        String testFileName = "test/tometamodel/TestData/avalon.meta.pl";
        avalon.tometamodel.GenDomainClasses.main(testFileName);
        appTestIt("Start", "ClassViolet", "Metamodel", "Meta", "Schema", "AvalonSpec", "VioletPl");
        GenMainClasses.init = false;
        GenLibs.init = false;
    }

    public void avalonGenMainClasses() {
        String testFileName = "test/tometamodel/TestData/avalon.meta.pl";
        avalon.tometamodel.GenMainClasses.main(testFileName);
        appTestIt("Debug", "Main");
    }

    public void avalonGenLibs() {
        String testFileName = "test/tometamodel/TestData/avalon.meta.pl";
        avalon.tometamodel.GenLibs.main(testFileName);
        testitlib("libpl/meta.run.pl", "libpl/violetpl.run.pl");
        testitlib("libpl/meta.schema.pl", "libpl/violetpl.schema.pl");
    }

    private void appTestIt(String... names) {
        for (String filename : names) {
            String theFile = "src/avalon/" + filename + ".java";
            RegTest.Utility.validate("boot/" + theFile, theFile, false);
        }
    }

    private void testitlib(String... names) {
        for (String filename : names) {
            RegTest.Utility.validate(filename, "boot/" + filename, false);
        }
    }

}
