package tometamodel;

import avalon.tometamodel.common;
import avalon.tometamodel.GenLibs;
import avalon.tometamodel.GenMainClasses;
import CoreMDELite.Globals;
import CoreMDELite.PrologObject;
import java.io.PrintStream;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 *
 * @author don
 */
public class CDExchangeBootStrapTest extends common {

    public CDExchangeBootStrapTest() {
        RegTest.Utility.init();
        Globals.setHomePath(false);
        avalon.Main.setAppPath(false);
        Globals.cleanup = false;
    }

    @Before
    public void setUp() {
        copy2MainDir("nopos.schema.pl");
        copy2MainDir("pos.schema.pl");
        copy2MainDir("sdb.schema.pl");
        copy2MainDir("violetdb.schema.pl");
        copy2MainDir("yumldb.schema.pl");
    }

    public void copy2MainDir(String file) {
        PrintStream out = null;
        String original = "../CDExchange/libpl/" + file;
        try {
            out = new PrintStream(file);
        } catch (Exception e) {
            System.err.println("file "+file+" not found");
            assert (false);
        }
        PrologObject.addFiletoPS(original, out);
        out.close();
    }

    @After
    public void tearDown() {
    }

    @Test
    public void mdeliteappTest() {
        cdexchangeGenDomainClasses();
        cdexchangeGenMainClasses();
        cdexchangeGenLibs();
    }

    public void cdexchangeGenDomainClasses() {
        String testFileName = "test/tometamodel/TestData/cdexchange.meta.pl";
        avalon.tometamodel.GenDomainClasses.main(testFileName);
        mdeliteappTestIt("src/cdexchange/", ".java", "Violet", "Dot", "Kielerdot", "Nopos", "VioletDB",
                "Yuml", "YumlDB", "Sdb", "Pos", "Start"); 
        GenMainClasses.init = false;
        GenLibs.init = false;
    }

    public void cdexchangeGenMainClasses() {
        String testFileName = "test/tometamodel/TestData/cdexchange.meta.pl";
        avalon.tometamodel.GenMainClasses.main(testFileName);
        mdeliteappTestIt("src/cdexchange/", ".java", "Debug", "Main");
    }

    public void cdexchangeGenLibs() {
        String dir = "test/tometamodel/TestData/";
        String testFileName = dir + "cdexchange.meta.pl";
        avalon.tometamodel.GenLibs.main(testFileName);
        mdeliteappTestIt("libpl/", ".schema.pl", "nopos", "sdb", "violetdb", "yumldb");
    }

    private void mdeliteappTestIt(String subdir, String postfix, String... names) {
        for (String filename : names) {
            String theFile = "../CDExchange/" + subdir + filename + postfix;
            RegTest.Utility.validate("boot/" + subdir + filename + postfix, theFile, false);
        }
    }
}
