package cdexchange.classVioletParser;

import java.util.ArrayList;

public class ClassNode extends ClassInterface {

    private ArrayList<String> attributes;
    protected String parentId = "";
    String fileName;

    public ClassNode(String id, String classType,String fileName) {
        super(id, classType);

        attributes = new ArrayList<>();
        this.fileName = fileName;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parId) {
        String stripped  = Main.makeFirstLowerCase(parId);
        if (this.parentId.equals("")) {
            this.parentId = stripped;
        } else {
            Main.errout("multiple superclasses for class " + name);
        }
    }

    public void setAttributes(String attribute) {
        String unstripped = Main.makeFirstLowerCase(attribute.trim());
        String stripped = unstripped.replace("\"","");
        if (unstripped.length()>2+stripped.length()) {
            Main.errout("too many quotes in ("+attribute+") in class "+name);
            return;
        }
        if (attributes.contains(stripped) || attributes.contains(unstripped)) {
            Main.errout("multiple attributes with name "+stripped+" in classId "+this.id);
        }
        this.attributes.add(attribute);
    }

    public ArrayList<String> getAttributes() {
        return attributes;
    }

    @Override
    public String toString() {
        String str = super.toString();

        str += ", Attributes:";
        for (String attribute : attributes) {
            str += " " + attribute;
        }

        return str;
    }
}
