/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cdexchange.classVioletTParser;

import cdexchange.classVioletTParser.Globals.EdgeType;
import java.util.HashMap;
/**
 *
 * @author trentkan
 */
public class Edge {    
    
    private String id;
    private String startID;
    private String endID;
    private String startLabel;
    private String middleLabel;
    private String endLabel;
    
    private EdgeType edgeType;
    private boolean interfaceStart;
    private boolean interfaceEnd;
     
    // params = [id, startID, endID, startLabel, middleLabel, endLabel]
    // iface = [ifaceStart, ifaceEnd]
    public Edge(String[] params, EdgeType et, boolean[] iface)
    {
        id = params[0];
        startID = params[1];
        endID = params[2];
        startLabel = params[3];
        middleLabel = params[4];
        endLabel = params[5];
        edgeType = et;
        interfaceStart = iface[0];
        interfaceEnd = iface[1];
    }
    
    public String toString()
    {
        StringBuilder sb = new StringBuilder("violetAssociation(");

        String[] endTypes = assignEndTypes();
        String type1 = endTypes[0];
        String type2 = endTypes[1];
        String[] shapesAndLineStyle = assignShapesAndLineStyle();
        String shape1 = shapesAndLineStyle[0];
        String shape2 = shapesAndLineStyle[1];
        String lineStyle = shapesAndLineStyle[2];        
        
        sb.append(id.concat(","));
        sb.append(quote(startLabel).concat(","));
        sb.append(shape1.concat(","));
        sb.append(type1.concat(","));
        sb.append(quote(endLabel).concat(","));
        sb.append(shape2.concat(","));
        sb.append(type2.concat(","));
        sb.append(lineStyle.concat(","));
        sb.append(startID.concat(","));
        sb.append(endID.concat(")."));
        
        return sb.toString();
    }
    
    // Assigns end types (either classnode or interfacenode)
    private String[] assignEndTypes()
    {
        String type1 = "";
        String type2 = "";
        if(interfaceStart && interfaceEnd)
        {       
            type1 = quote("interfacenode");
            type2 = quote("interfacenode");
        }
        else if(interfaceStart)
        {
            type1 = quote("interfacenode");
            type2 = quote("classnode");
        }
        else if(interfaceEnd)
        {
            type1 = quote("classnode");
            type2 = quote("interfacenode");
        }
        else
        {
            type1 = quote("classnode");
            type2 = quote("classnode");
        }
        String[] retVal = {type1, type2};
        return retVal;
    }
    
    // Returns shapes and the line style of an association
    // based on the association type
    private String[] assignShapesAndLineStyle()
    {
        String shape1 = "\'\'";
        String shape2 = "";
        String lineStyle = "";
        switch (edgeType)
        {
            case EXTENDS:
                shape2 = quote("TRIANGLE");
                lineStyle = quote("");
                break;
            case IMPLEMENTS:
                shape2 = quote("TRIANGLE");
                lineStyle = quote("DOTTED");
                break;
            case DEPENDS:
                shape2 = quote("V");
                lineStyle = quote("DOTTED");
                break;
            case ASSOCIATION:
                shape2 = quote("V");
                lineStyle = quote("");
                break;
            case AGGREGATION:
                shape2 = quote("DIAMOND");
                lineStyle = quote("");
                break;
            case COMPOSITION:
                shape2 = quote("BLACK_DIAMOND");
                lineStyle = quote("");
                break;
        }
        String[] retVal = {shape1, shape2, lineStyle}; 
        return retVal;
    }
    
    private String quote(String original)
    {
        return "\'" + original + "\'";
    }
}
