/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cdexchange.classVioletTParser;

/**
 *
 * @author trentkan
 */
public class Node {
    
    private String id;
    private String name;
    private String attributes;
    private String methods;
    private String xValue;
    private String yValue;
    
    private boolean isClass; // True then class, else interface
         
    // Params = [id, name, attributes, methods, x, y]
    public Node(String[] params, boolean isClass)
    {
        assert(params.length == 6);        
        this.id = params[0];
        this.name = params[1];
        this.attributes = params[2];
        this.methods = params[3];
        this.xValue = params[4];
        this.yValue = params[5];
        this.isClass = isClass;
    }
    
    public String toString()
    {
        StringBuilder sb;
        if(isClass)
        {
            sb = new StringBuilder("violetClass(");
        }
        else
        {
            sb = new StringBuilder("violetInterface(");
        }
        // Append id
        sb.append(id.concat(","));
        // Append name and check for weird character in interface
        if(name.contains("Â«interfaceÂ»"))
        {
            // skip past space
            int index = name.indexOf('»') + 1;
            name = quote(name.substring(index)).concat(",");
        }
        else
        {
            name = quote(name).concat(",");
        }
        sb.append(name);
        // Add fields if node is class, otherwise do nothing
        if(isClass)
        {
            attributes = quote(attributes).concat(",");
            sb.append(attributes);
        }
        methods = quote(methods).concat( ",");
        sb.append(methods);
                
        xValue = xValue.concat(",");
        yValue = yValue.concat(").");
        sb.append(xValue);
        sb.append(yValue);
        return sb.toString();
    }
    
    private String quote(String original)
    {
        return "\'" + original + "\'";
    }
    
    public boolean isClass()
    {
        return isClass;
    }
}
