/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cdexchange.classYumlParser;

/**
 *
 * @author dsb
 */
public class klass {

    static final String comma = ",";
    static final String quote = "'";
    // variables
    public String id = "";
    public String name = "";
    public String fields = "";
    public String methods = "";
    public int    lineNumber =0;

    public klass(String[] array, int lineNumber) {
        this(array[0], array[1], array[2], lineNumber);
    }

    public klass(String n, String f, String m, int lineNumber) {
        name = n.trim();
        // here's the trick -- there could be prior "declarations" of a klass in yuml.
        // once a field or method is entered, then that is THE definition.  Otherwise,
        // any klass that has a name can be modified subsequently.
        klass k = Main.klassS.get(name);
        if (k != null) {  // klass has been encountered before
            if (k.fields.equals("") && k.methods.equals("")) {
                // this is a previously "empty" declaration.  I'll fill it in now
                k.fields = f.trim();
                k.methods = m.trim();
                k.lineNumber = lineNumber;
            }
            return;  // although we return a klass object, it is not in the klassS container!
     
        }

        // otherwise -- create a fresh klass
        if (  name.equals("") || isInterface(name) && stripInterface(name).equals("") ){
            Main.eps.format("%d: class or interface cannot have an empty name\n", lineNumber);
        }
        id = "c" + Main.kounter++;
        fields = f.trim();
        methods = m.trim();
        this.lineNumber = lineNumber;
        Main.klassS.put(name, this);
    }

    public static void writeNodeTuples() {
        boolean dynamic = true;
        Main.out.println("table(yumlClass,[id,\"name\",\"fields\",\"methods\"]).");
        for (klass i : Main.klassS.values()) {
            if ( !isInterface(i.name) ) {
                Main.out.println("yumlClass(" + i.id + comma + quote + i.name + quote + comma
                        + quote + i.fields + quote + comma + quote + i.methods + quote + ").");
                dynamic = false;  // we've output one tuple
            }
        }
        if (dynamic) {
            Main.out.println(":- dynamic yumlClass/4.");
        }
        Main.out.println();

        dynamic = true;
        Main.out.println("table(yumlInterface,[id,\"name\",\"methods\"]).");
        for (klass i : Main.klassS.values()) {
            if (  isInterface(i.name)  ) {
                String iname = stripInterface(i.name);   // past "interface "
                if (!i.fields.equals("")) {
                    Main.eps.format("%d: class (%s) defined as interface\n", i.lineNumber, i.name);
                }
                Main.out.println("yumlInterface(" + i.id + comma + quote + iname + quote + comma
                        + quote + i.methods + quote + ").");
                dynamic = false;  // we've output one tuple
            }
        }
        if (dynamic) {
            Main.out.println(":- dynamic yumlInterface/3.");
        }
        Main.out.println();
    }

    public static String toId(String name) {
        klass k = Main.klassS.get(name);
        if (k == null) {
            Main.eps.println("unknown class " + name);
            return "c-1"; // something that will make Prolog complain
        } else {
            return k.id;
        }
    }
    
    static final int skip = "Interface".length();
    
    static boolean isInterface(String name) {
        return name.startsWith("Interface") || name.startsWith("interface");
    }
    
    static String stripInterface(String name) {
        String result = name.substring(skip).trim();
        return result;
    }
}
