package cdexchange.kielerDot2Pos;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import CoreMDELite.Error;
import CoreMDELite.Globals;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.util.StringTokenizer;

/**
 *
 * @author dsb
 */
public class Main {

    static PrintStream ps, eps;

    static String infile = null;
    static String outfile = null;

    public Main() {
    } // pacify a whiny compiler

    /**
     * @param args the command line arguments
     */
    public static void main(String... args) {

        if (args.length != 2) {
            System.err.format("Usage: %s <infile.dot> <outfile.pl>\n", Main.class.getName());
            System.exit(1);
        }

        infile = args[0];
        outfile = args[1];

        try {
            ps = new PrintStream(outfile);
            eps = new PrintStream(Globals.errorFile);
        } catch (FileNotFoundException ex) {
            throw new Error("cannot open file " + outfile + " for writing");
        }

        readFile(infile);
        ps.close();
        eps.close();
    }

    static int lineCounter;

    static void readFile(String filename) {
        String line;
        LineNumberReader r;

        lineCounter = 0;

        try {
            r = new LineNumberReader(new FileReader(filename));
        } catch (FileNotFoundException ex) {
            throw new Error("unable to open file: " + filename);
        }
        ps.println("table(pos,[id,x,y,\"cid\"]).");

        while (true) {
            int number = r.getLineNumber();
            try {
                line = r.readLine();
            } catch (IOException ex) {
                throw new Error("unable to read line " + number + " in file: " + filename);
            }
            if (line == null) {
                break;
            }
            //System.out.println(number + ": " + line);
            if (line.startsWith("diagraph")) {
                continue;
            }
            if (line.startsWith("graph")) {
                continue;
            }
            if (line.startsWith("}")) {
                continue;
            }
            if (line.contains("--")) {
                continue;
            }
            if (line.contains("->")) {
                continue;
            }
            if (!line.contains("[")) {
                continue;
            }
            translateNodeLine(line);
        }
        try {
            r.close();
        } catch (IOException ex) {
            throw new Error("unable to close file: " + filename);
        }
        ps.println("pos(A,B,C,D):-pos1(A,B,C,E),class(E,D,_,_,_).");
        ps.println("pos(A,B,C,D):-pos1(A,B,C,E),interface(E,D,_).");
    }

    static final int Xscale = 5;
    static final int Yscale = 4;

    static void translateNodeLine(String line) {
        StringTokenizer st = new StringTokenizer(line, ". \",");
        String nodeid = st.nextToken().trim();
        String poseq = st.nextToken();
        String x = st.nextToken();
        String xdec = st.nextToken();
        String y = st.nextToken();
        String ydec = st.nextToken();
        // note the scaling
        int xi = Integer.parseInt(x) * Xscale;
        int yi = Integer.parseInt(y) * Yscale;

        ps.format("pos1(id%d,%d,%d,'%s').\n", lineCounter++, xi, yi, nodeid);
        //ps.println("position(" + nodeid + comma + x + comma + y + ").");
    }
}
