/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CDExchange;

import cdexchange.YumlDB;
import cdexchange.Sdb;
import cdexchange.Main;
import cdexchange.Yuml;
import CoreMDELite.ConformanceError;
import CoreMDELite.Error;
import CoreMDELite.Globals;
import RegTest.Utility;
import static org.junit.Assert.fail;
import org.junit.Test;

/**
 *
 * @author dsb
 */
public class YumlRoundTripTest {

    public YumlRoundTripTest() {
        RegTest.Utility.init();
        Globals.setHomePath(false);
        Main.setAppPath(false);
        Globals.cleanup = false;
    }

    @Test
    public void Main1() {
        doit("noLinks");
    }

    @Test
    public void Main2() {
        doit("wLinks");
    }

    @Test
    public void Main3() {
        doit("Notepad");
    }
    
    @Test
    public void Main4() {
        doit("1Standard");
    }

    public void doit(String filename) {
        shortTrip(filename);
        longTrip(filename);
    }
    

    public void longTrip(String fileName) {
        Yuml v1 = null;
        
        try {
            Yuml y = new Yuml("TestData/YumlRoundTrip/"+fileName);
            YumlDB ypl = y.yclass2yuml();
            Sdb sdb = ypl.yuml2sdb();
            sdb.newVersionNumber();
            YumlDB vpl1 = sdb.sdb2yuml();
            v1 = vpl1.toYclass();
        } catch (Error e) {
            fail(e.getMessage());
        } catch (ConformanceError e) {
            fail(e.getMessage());
        }
        Utility.validate(v1.fullName, "Correct/TestData/YumlRoundTrip/"+fileName+"L.yuml.yuml", true);
    }
     
    
    public void shortTrip(String fileName) {
        Yuml vs = null;
        try {
            Yuml y = new Yuml("TestData/YumlRoundTrip/"+fileName);
            YumlDB ypl = y.yclass2yuml();
            ypl.newVersionNumber();
            vs = ypl.toYclass();
        } catch (RuntimeException e) {
            fail(e.getMessage());
        }
        Utility.validate(vs.fullName, "Correct/TestData/YumlRoundTrip/"+fileName+"S.yuml.yuml", true);
    }
}
