/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CoreMDELite;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;

/**
 *
 * @author dsb
 */
public abstract class GProlog extends MDELiteObject {

    public GProlog(String filename, String[] files) {
        super(filename);
        mergeFiles(files);
    }

    // these empty constructors are needed because obscure run-time
    // exceptions are raised otherwise that take 1/2 to track down
    public GProlog(String filename) {
        super(filename);
    }

    private GProlog() {
    }  // shouldn't be called.

    // the result of merged files is the new value of the given object
    protected void mergeFiles(String[] filenames) {
        try {
            PrintStream ps = getPrintStreamForCurrentMDELiteObject();
            for (String f : filenames) {
                stuff(f, ps);
            }
            ps.flush();
            ps.close();
        } catch (Exception e) {
            done(e);
        }
    }

    protected static void stuff(String inFileName, PrintStream ps) {
        try {
            BufferedReader br = new BufferedReader(new FileReader(inFileName));
            while (true) {
                String line = br.readLine();
                if (line == null) {
                    break;
                }
                ps.println(line);
            }
        } catch (Exception e) {
            throw new Error (e.getMessage());
        }
    }

    // executes a prolog object.  The execution produces a file, whose object is created prior to the call
    // I know this is strange but this is a general problem of run-time objects being paired with files
    // at some point, one will exist before the other
   
    
    public void executeProlog(MDELiteObject out) {
        
        try {
            PrintStream ps;
            ps = new PrintStream(Globals.scriptFile);
            ps.print(":-['" + fullName + "'],tell('" + out.fullName + "'),run,told,halt.");
            ps.flush();
            ps.close();
        } catch (Exception e) {
            throw new Error (e.getMessage());
        }
      
        try {
            executeCommandLine(Globals.swipl, "--quiet", "-f", Globals.scriptFile);
        } catch (Exception e) {
            System.err.println("MDELite halts -- SWI Prolog Errors detected");
            System.err.println("consult " + Globals.errorFile);
            System.err.println("debug this prolog file:  " + fullName);
            throw new Error (e.getMessage());
        }
        File s = new File(Globals.scriptFile);
        s.delete();
    }

    // this method is used to test conformance of a database 
    // with its constraints.  it is coded only for this purpose
    // as it outputs nothing.
    public void executeProlog() throws RuntimeException {
        try {
            PrintStream ps;
            ps = new PrintStream(Globals.scriptFile);
            ps.print(":-['" + fullName + "'],tell('" + Globals.conformFile + "'),run,told,halt.");
            ps.flush();
            ps.close();
        } catch (Exception e) {
            throw new Error (e.getMessage());
        }
        
        try {
            executeCommandLine(Globals.swipl, "--quiet", "-f", Globals.scriptFile);
        } catch (Exception e) {
            System.err.println("MDELite halts -- SWI Prolog Errors detected");
            System.err.println("consult "+ Globals.errorFile);
            System.err.println("debug this prolog file:   " + fullName);
            System.err.println(Globals.conformanceFailure);
            throw new Error (e.getMessage());
        }
        File c = new File(Globals.conformFile);
        if (c.length()!= 0) {
            String msg = Globals.conformanceFailure + "\n" + "look at " + Globals.scriptFile + " and conformance errors in " + Globals.conformFile;
            throw new Error (msg);
        }
        c.delete();
        File s = new File(Globals.scriptFile);
        s.delete();
    }
    
    public abstract void conform();
}
