/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CoreMDELite;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

/**
 *
 * @author don
 */
public class Globals {
    
    // read the config.properties file in either the NetBeans Project home or the local directory (this is decided by HomePath.setHomePath()
    // the only setting is where the swipl executable is.
    static {
        String cp = "not initialized";
        try {
            setHomePath(false);
            cp = Globals.homePath + Globals.configFile;
            Properties cf = new Properties();
            cf.load(new FileInputStream(cp));
            Globals.swipl = cf.getProperty("SWI_PROLOG_LOCATION");
        } catch (IOException e) {
            System.err.println(e.getMessage());
            System.err.format("Error in loading %s file\n", cp);
            System.err.println("MDELite halts");
            throw new Error(e.getMessage());
        }
    }
    
    // computed globals
    public static String homePath;                                 // assigned by HomePath.setHomePath
    public static String appPath;                                  // assigned by static Main in MDELite application
    public static String swipl;                                    // assigned by HomePath.setHomePath
    
    // debugging constants
    public static boolean cleanup = true;                          // do we set delete on exit?  to clean-up the mess of files
                                                                   // produced by MDELite computation
    
    // constants
    public final static String scriptFile  = "script.txt";          // name of swi-prolog script file
    public final static String configFile  = "config.properties";   // name of local configuration file
    public final static String errorFile   = "error.txt";           // name of error file (where non-conformance errors are listed)
    public final static String conformFile = "conform.txt";         // name of conformance error file (where metamodel constraint errors are listed)
    public final static String vm2tFile    = "vm2toutput.txt";      // name of the default vm2t output file
    
    // standard names
    public static final String conformanceFailure = "Conformance Failure";

    // used only to set homepath and application paths
    public static String getPath(Class me) {
        String tmp = me.getProtectionDomain().getCodeSource().getLocation().getPath();
        if (tmp.startsWith("/") && tmp.contains(":")) {
            tmp = tmp.substring(1);
        }
        // Step 2: more cleanup -- exactly why this works I no longer remember :-(
        int pos;
        if (tmp.contains("build/classes/")) {
            pos = tmp.lastIndexOf("build/classes/");
        } else {
            pos = tmp.lastIndexOf("/") + 1;
        }
        tmp = tmp.substring(0, pos);
        if (!tmp.contains(":")) {
            tmp = "/" + tmp;
        }
        return tmp;
    }

    //public static String homePath = "";
    public static void setHomePath(boolean printMe) {
        Class me = Globals.class;
        Globals.homePath = getPath(me);
        if (printMe) {
            System.out.println("HomePath: " + Globals.homePath);
        }
    }

    // for debugging
    public static void main(String[] args) {
        setHomePath(true);
    }
}
