/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CoreMDELite;

import PrologDB.Table;
import PrologDB.Tuple;
import java.io.File;
import java.io.PrintStream;

/**
 *
 * @author don
 */
public class Validate {

    public static void marquee() {
        System.out.println("Usage: Validate <appname>");
        System.out.println("       where <appname>.meta.pl is a local file");
        System.out.println("       this program will check to see if all files referenced in <appname>.meta.pl");
        System.out.println("       are present.");
    }

    public static void main(String[] args) {
        File inputFile, p;
        PrintStream eps;
        String fileName, pn, exe, ext, dom;
        boolean hasErrors = false;

        // Step 1: let's make sure we open everything properly
        if (args.length != 1) {
            marquee();
            return;
        }
        fileName = args[0] + ".meta.pl";
        try {
            inputFile = new File(fileName);
        } catch (Exception e) {
            throw new Error("can't open file " + fileName);
        }
        try {
            eps = new PrintStream(Globals.errorFile);
        } catch (Exception e) {
            throw new Error("can't open file " + Globals.errorFile);
        }
        PrologDB.DB db = PrologDB.ReadPrologDB.readDataBase(inputFile, eps);
        eps.close();

        // Step 2: foreach method, see if its executable is present
        Table methodTable = db.getTable("method");
        if (methodTable == null) {
            throw new Error("Cannot find method table in " + fileName + " !");
        }
        for (Tuple m : methodTable.getTuples()) {
            ext = m.get("ext");
            exe = m.get("filename");
            switch (ext) {
                case "java":
                    try {
                        Class.forName(exe);
                    }
                    catch (Exception e) {
                        System.out.println("java program "+ exe + " is not in your classpath");
                        hasErrors = true;
                    }
                    break;
                case "vm":
                    hasErrors = doesFileExist("libvm/"+exe+".vm", "velocity script ", " is not in libvm/ directory") || hasErrors;
                    break;
                case "pl":
                    hasErrors = doesFileExist("libpl/"+exe+".pl", "prolog program ", " does not exist in libpl/") || hasErrors;
                    break;
                default:
                    System.out.println("Unregoznizable executable extension "+ exe);
                    hasErrors = true;
            }
        }
        
        // Step 3: foreach class, if it is a prolog file, then it must have 3 libpl files
        Table classTable = db.getTable("class");
        if (classTable == null) {
            throw new Error("Cannot find class table in " + fileName + " !");
        }
        for (Tuple c : classTable.getTuples()) {
            ext = c.get("ext");
            dom = c.get("domain");
            
            if (ext.equals("pl")) {
                hasErrors = doesFileExist("libpl/"+dom+".schema.pl",  "prolog file ", " does not exist in libpl/") || hasErrors;
                hasErrors = doesFileExist("libpl/"+dom+".conform.pl", "prolog file ", " does not exist in libpl/") || hasErrors;
                hasErrors = doesFileExist("libpl/"+dom+".run.pl",     "prolog file ", " does not exist in libpl/") || hasErrors;
            }
        }
    }

    static boolean doesFileExist(String name, String header, String footer) {
        File p = new File(name);
        if (!p.exists()) {
            System.out.println(header + name + footer);
            return false;
        }
        return true;
    } 
}
