/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package PrologDB;

import CoreMDELite.Error;

/**
 *
 * @author trentkan
 */
public class Column {
    
    private final String name;
    private final boolean isQuoted;
    
    public Column(String name, boolean isQuoted)       
    {
        this.name = name;
        this.isQuoted = isQuoted;
    }
    
    public String getName()
    {
        return name;
    }
    
    public boolean isQuoted()
    {
        return isQuoted;
    }
    
    @Override
    public String toString()
    {   
        String q = isQuoted?"\"":"";
        return q + name + q;
    }
    
    public void equals(Column otherColumn)
    {
        if(otherColumn == null)
        {
            throw new Error("column is empty");
        }
        String tempName = otherColumn.getName();
        if(!name.equals(tempName))
        {
            throw new Error("column names ("+name+","+tempName+") do not match");
        }
        if (isQuoted != otherColumn.isQuoted())
        {
            throw new Error("quotations in column names ("+name+","+tempName+") do not match");
        }
    }
}
