/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package PrologDB;

import CoreMDELite.Error;
import java.io.PrintStream;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author trentkan
 */
public class DB {
 
    private Map<String, Table> tables;
    private DBSchema schema;
        
    public DB(DBSchema schema)
    {
        this.schema = schema;
        tables = new HashMap<>();
        for (TableSchema t : schema.getTableSchemas()) {
            tables.put(t.getName(), new Table(t));
        }
    }
    
    public DB addTable(Table t) {
        tables.put(t.getName(),t);
        return this;
    }
    
    public DBSchema getSchema() { 
        return schema;
    }
    
    public Collection<Table> getTables() {
        return tables.values();
    }
    
    public TableSchema getTableSchema(String name){
        return schema.findTableSchema(name);
    }
    
    
    /*********** Find utilities ******************/
    public Table getTable(String tableName) {
        Table t = tables.get(tableName);
        if (t != null)
            return t;
        throw new Error("cannot find table "+tableName + " in database "+ schema.getName());
    }

    public boolean containsTable(String name)
    {
        return tables.containsKey(name);
    }

    public void print(PrintStream out) {
        out.format(":-style_check(-discontiguous).\n\n");
        out.format("%s\n",schema.printHeader());
        
        for (TableSchema s : schema.getTableSchemas()) {
            Table t = tables.get(s.getName());
            t.print(out);
        }
    }
}
