/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package PrologDB;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author don
 */
public class SubTableSchema {

    TableSchema supr;
    List<TableSchema> subs;

    public SubTableSchema(TableSchema supr) {
        this.supr = supr;
        subs = new ArrayList<>();
    }
    
    public SubTableSchema(TableSchema supr, List<TableSchema> subs) {
        this.supr = supr;
        this.subs = subs;
    }

    public void addSubTableSchema(TableSchema sub) {
        subs.add(sub);
    }
    
    public void addSubTableSchemas(List<TableSchema> subs) {
        this.subs.addAll(subs);
    }
    
    public String getName() { 
         return supr.getName();
    }
    
    public TableSchema getSuper() {
        return supr;
    }

    // push attributes of super table into subtable
    public void flatten() {
        List<Column> columns = supr.getColumns();
        for (TableSchema t : subs) {
            t.addColumns(columns);
        }
    }
    
    public boolean contains(TableSchema s) {
        return subs.contains(s);
    }

    public void print(PrintStream out) {
        out.format("subtable(%s,[", supr.getName());
        String comma = "";
        for (TableSchema s : subs) {
            out.format("%s%s", comma, s.getName());
            comma = ",";
        }
        out.format("]).\n");
    }

    public void printInheritanceRules(PrintStream out) {
        String pList = supr.varList(0);
        String nList = "";

        for (TableSchema n : subs) {
            nList = n.varList(n.size() - supr.size());
            out.format("%sALL(%s):-%sALL(%s).\n", supr.getName(), pList, n.getName(), nList);
        }
    }
}
