/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package PrologDB;

import CoreMDELite.Error;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author trentkan
 */
public class Table {

    protected final String name;
    protected final TableSchema schema;
    private List<Tuple> tuples;

    public Table(TableSchema schema) {
        this.name = schema.getName();
        this.schema = schema;
        tuples = new ArrayList<>();
    }
    
    public Table(String name) {
        this.name = name;
        this.schema = null;
        tuples = new ArrayList<>();
    }
    
    public String getName() {
        String result = (name == null)?schema.getName(): name;
        return result;
    }
    
    public TableSchema getSchema() {
        return schema;
    }
    
    public List<Tuple> getTuples() {
        return tuples;
    }
    
    public int size() {
        return tuples.size();
    }

    public void addTuple(Tuple t) {
        tuples.add(t); // append
    }

    public Tuple findFirst(String column, String value) {
        for (Tuple t : tuples) {
            if (t.get(column).equals(value)) {
                return t;
            }
        }
        throw new Error("can't find tuple in relation " + schema.getName() + " where " + column + "=" + value);
    }
    
    public void print(PrintStream out) {
        if (schema == null)
            throw new Error("schema not set in table " + name);
        schema.print(out);
        for (Tuple t : tuples) {
            t.print(out);
        }
        if (tuples.isEmpty()) {
            out.format(":- dynamic %s/%d.\n",schema.getName(),schema.size());
        }
        out.format("\n");
    }
}
