/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package PrologDB;

import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author trentkan
 */
public class Tuple {

    private final TableSchema schema;
    private Map<String, String> values;

    public Tuple(TableSchema schema) {
        this.schema = schema;
        values = new HashMap<>();
    }

    public Tuple addColumnValue(String name, String value) {
        schema.findColumn(name);  // throws error if non-existent
        values.put(name, value);
        return this;
    }

    public String get(String key) {
        return values.get(key);
    }

    public void print(PrintStream out) {
        if (values.size() != schema.size())
            throw new Error("tuple from table "+schema.getName() + " does not have correct number of attributes");
        String q;
        String tuple = schema.getName() + "(";
        String comma = "";
        for (Column c : schema.getColumns()) {
            q = c.isQuoted() ? "'" : "";
            String val = values.get(c.getName());
            if (val == null) 
                val = "null";
            tuple = tuple + comma + q + val + q;
            comma = ",";
        }
        tuple = tuple + ").\n";
        out.format(tuple);
    }
}
