/* file: violet2sdb.pl */

/*********** translation of violetClass to class tuples *************/
inherit(N,N1):-violetAssociation(_,_,'TRIANGLE',_,_,_,_,_,N1,N),violetClass(N1,_,_,_,_,_),!.
inherit(N,N1):-violetAssociation(_,_,_,_,_,'TRIANGLE',_,_,N,N1),violetClass(N1,_,_,_,_,_),!.
inherit(_,null).
class(I,N,F,M,S):-violetClass(I,N,F,M,_,_),inherit(I,S).
pos(Id,X,Y,I):-entity(Id,X,Y,I).
entity(Id,X,Y,I):-violetClass(Id,I,_,_,X,Y).
entity(Id,X,Y,I):-violetInterface(Id,I,_,X,Y).




/*********** translation of violetInterface to interface tuples *************/
interface(I,N,M):-violetInterface(I,N,M,_,_).
pos(I,X,Y):-violetInterface(I,_,_,X,Y).

/*********** translation to violetAssociation to violetAssociation, classImplements, and interfaceExtends tuples *************/
xlate('V',arrow).
xlate('TRIANGLE',implem).
xlate('TRIANGLE',inherit).
xlate('TRIANGLE',inherit).
xlate('DIAMOND',agg).
xlate('BLACK_DIAMOND',comp).
xlate('',none).
association(Id,R1,A1,R2,A2,I1,I2):-violetAssociation(Id,R1,Arrow1,_,R2,Arrow2,_,_,I1,I2),
                    not(Arrow1=='TRIANGLE'),not(Arrow2=='TRIANGLE'),
                    xlate(Arrow1,A1),xlate(Arrow2,A2).
classImplements(Id,C,I):-violetAssociation(Id,_,'TRIANGLE','interfacenode',_,'','classnode',_,I,C).
classImplements(Id,C,I):-violetAssociation(Id,_,'','classnode',_,'TRIANGLE','interfacenode',_,C,I).

interfaceExtends(Id,B,X):-violetAssociation(Id,_,'TRIANGLE','interfacenode',_,'','interfacenode',_,B,X).
interfaceExtends(Id,B,X):-violetAssociation(Id,_,'','interfacenode',_,'TRIANGLE','interfacenode',_,X,B).

:-dynamic entity/1.


